/****************************************
 IGS̕ǂݍŏ̂ɕKvȃvO
 ENRI̍䂳E䂳̃vOgݍ킹Ďgp

 2010 Katsuhiro Morishita
*****************************************/

#include "IGS.h"

#define PRN_MAX	32
#define	VALUES_SIZE	100
#define Str2values(ans, buff, buff_size)	Strn2values(ans, 0, buff, buff_size)


const char *eph_member[IGS_EPH_DATA_SIZE] = {"PRN_NUM", "YEAR", "MONTH", "DAY", "HOUR", "MINUTE", 
									"SECOND", "SV_CLOCK_BIAS", "SV_CLOCK_DRIFT", "SV_CLOCK_DRIFT_RATE", 
									"IODE", "Crs", "DELTA_N", "M0", 
									"Cuc", "e_ECCENTRICITY", "Cus", "SQRT_A",
									"TOE", "Cic", "OMEGA", "Cis", 
									"i0", "Crc", "omega", "OMEGA_DOT", 
									"i_DOT", "CODE_ON_L2_CH", "GPS_WEEK_NUM", "L2_P_DATA_FLAG",
									"SV_ACCURACY", "SV_HEALTH", "TGD", "IODC", 
									"TOM", "FIT_INTERVAL", "SPARE1", "SPARE2"};


// Oϐ̐錾

/****************************************************
vZpGtFXփf[^Rs[

	G[͖̂Œ
	JJnF2010/6/26

	FϊIGStH[}bgɂȂĂGtFX
	ԒlFENRI̕ƍ䂳񂪊J֐g߂ɁAIGStH[}bg̃f[^ENRIɕϊ
 ****************************************************/

ephemeris IGS_eph2culc_eph(IGS_EPHEMERIS_UN igs_eph){
	ephemeris ans;
	

	ans.PRN_num							= (int)igs_eph.ST.PRN_NUM;
	ans.year							= (int)igs_eph.ST.EPOCH.YEAR ;
	ans.month							= (int)igs_eph.ST.EPOCH.MONTH ;
	ans.day								= (int)igs_eph.ST.EPOCH.DAY;
	ans.hour							= (int)igs_eph.ST.EPOCH.HOUR;
	ans.minute							= (int)igs_eph.ST.EPOCH.MINUTE;
	ans.second							= igs_eph.ST.EPOCH.SECOND;
	ans.clock_bias						= igs_eph.ST.SV_CLOCK_BIAS;
	ans.clock_drift						= igs_eph.ST.SV_CLOCK_DRIFT;
	ans.clock_drift_rate				= igs_eph.ST.SV_CLOCK_DRIFT_RATE;
	ans.age_of_data_ephemerides			= igs_eph.ST.IODE;	// 
	ans.sine_term_for_r_correction		= igs_eph.ST.Crs;
	ans.mean_motion_difference			= igs_eph.ST.DELTA_N;   
	ans.mean_anomaly					= igs_eph.ST.M0;    
	ans.cosine_term_for_u_correction	= igs_eph.ST.Cuc; 
	ans.eccentricity					= igs_eph.ST.e_ECCENTRICITY;
	ans.sine_term_for_u_correction		= igs_eph.ST.Cus;  
	ans.square_root_of_semimajor_axis	= igs_eph.ST.SQRT_A; 
	ans.time_of_ephemerides				= igs_eph.ST.TOE;          
	ans.cosine_term_for_i_correction	= igs_eph.ST.Cic; 
	ans.nodes_longitude					= igs_eph.ST.OMEGA;           
	ans.sine_term_for_i_correction		= igs_eph.ST.Cic;    
	ans.inclination						= igs_eph.ST.i0;                
	ans.cosine_term_for_r_correction	= igs_eph.ST.Crc; 
	ans.argument_of_perigee				= igs_eph.ST.omega;           
	ans.rate_of_nodes_longitude			= igs_eph.ST.OMEGA_DOT;      
	ans.rate_of_inclination				= igs_eph.ST.i_DOT;         
	ans.codes_on_L2_channel				= igs_eph.ST.CODE_ON_L2_CH;
	ans.GPS_week						= igs_eph.ST.GPS_WEEK_NUM;
	ans.L2_P_data_flag					= igs_eph.ST.L2_P_DATA_FLAG;
	ans.satellites_accuracy				= igs_eph.ST.SV_ACCURACY;
	ans.satellites_health				= igs_eph.ST.SV_HEALTH;
	ans.ionospheric_group_delay			= igs_eph.ST.TGD;		
	ans.age_of_data_clock				= igs_eph.ST.IODC;
	ans.transmission_time_of_message	= igs_eph.ST.TOM;

	return ans;
}


// t@Cǂݍ݂Ƃ̃`FbN

// t@C̓ǂݍ

/****************************************************
sāA̐lsB

	G[͖̂Œ
	Xy[X}CiXŐVȐlƂĔFB
	JJnF2010/6/26

	Fans[] i[z(QƓnő), buff@l, buff_size ̃TCY
	ԒlFoꂽl̐
 ****************************************************/
 int Strn2values(double ans[], int ans_size, char buff[], int buff_size){
	double sign = 1.0, power;
	int i, k;
	int dot_found_flag;
	char c, backup = ' ';			// n߂̕Xy[XłOKȗlɁA' '

	i = k = 0;
	power = 1l;
	ans[k] = 0.0;
	dot_found_flag = 0;
	while(buff_size--){
		if(ans_size != 0 && (k + 1) > ans_size)break;	// obt@TCYzh~
		c = buff[i];									// f[^擾
		// l
		if(c >= '0' && c <= '9'){	
			ans[k] = ans[k] * 10.0 + (double)(c - '0');
			if(dot_found_flag)power *= 10.0;
		}else if(c == '.'){
			dot_found_flag = 1;
		}
		// Zp[gf
		// ľ͕ɕꍇAl̏IƂ݂Ȃ
		// lER[ȟɃXy[Xꍇɂ́Al̏IƂ݂Ȃ
		if(backup != ' ' && ((c == '-' || c == '+') || c == ' ')){	
			ans[k] *= sign;
			ans[k] /= power;
			power = 1l;
			dot_found_flag = 0;
			k++;
			ans[k] = 0.0;
			sign = 1.0;									// '+'͏ȗ邱Ƃ̂ŏ
		}
		// f
		if(c == '-'){
			sign = -1.0;
		}else if(c == '+'){
			sign = 1.0;
		}
		backup = c;
		i++;
	}
	return k + 1;
}

 /****************************************************
IGSRINEXtH[}bg̕ij󂯎AIGSpɗpӂ\̂֊i[ĕԂ

	G[͖̂Œ
	1q1G|bNׂĂ܂ޕKvB
	̍ہAsR[h폜ĂȂĂFB
	JJnF2010/6/26

	Fbuff@lRINEXtH[}bg̕ij
	ԒlFlꂽGtFX
 ****************************************************/
IGS_EPHEMERIS_UN Get_IGS_eph(char buff[]){
	double values[VALUES_SIZE];
	IGS_EPHEMERIS_UN ans;
	int i, size;

	for(i = 0;i < VALUES_SIZE; i++)values[i] = 0.0;				// ̏
	size = Strn2values(values, VALUES_SIZE, buff, strlen(buff));// 𐔒l
	//printf("\n size = %d\n", size);
	//for(i = 0;i < size;i++)printf("%10.10f\t",values[i]);
	//(void)puts("\n");
	for(i = 0;i < IGS_EPH_DATA_SIZE; i++)ans.DATA[i] = 0.0;				// ̏
	for(i = 0;i < 7; i++)ans.DATA[i] = values[i];				// PRNԍAG|bN͂̂܂܃Rs[
	//for(i = 0;i < 7;i++)printf("%10.10f\n", ans.DATA[i]);
	while(i < size){											// ̑̃f[^͉Ǝwɕ
		if((i % 2) == 0){
			//printf("%10.10f\n", values[i]);
			ans.DATA[6 + (i - 6)/ 2] = values[i - 1] * pow(10.0, values[i]);
			//printf("%d, %d, %f\n", 6 + (i - 6)/ 2, i - 1 , pow(10.0, values[i]));
		}
		i++;
	}

	return ans;
}

// p[^̏ó@eXgp
void IGS_eph_output(IGS_EPHEMERIS_UN data){
	int i;
	/*
	(void)printf("PRN number : %2d\t", (int)data.ST.PRN_NUM);
	(void)printf("EPOCH : %2d/%2d/%2d %2d:%2d:%2.1f\t",
		(int)data.ST.EPOCH.YEAR, (int)data.ST.EPOCH.MONTH, (int)data.ST.EPOCH.DAY,
		(int)data.ST.EPOCH.HOUR, (int)data.ST.EPOCH.MINUTE, data.ST.EPOCH.SECOND 
		);
	(void)printf("TOM:%7d TOM mod 30:%ld\t", (long int)data.ST.TOM, (long int)data.ST.TOM % 30l);
	(void)printf("TOE:%7d TOE-TOM:%ld\n", (long int)data.ST.TOE, (long)(data.ST.TOE - data.ST.TOM));
	*/
	for(i = 0;i < IGS_EPH_DATA_SIZE;i++)(void)printf("%s:%g\t", eph_member[i], data.DATA[i]);
	(void)puts("");
	return;
}
