#define IGS_EPH_DATA_SIZE	38

/*-------\\-----*/
typedef struct{
	double		YEAR;
	double		MONTH;
	double		DAY;
	double		HOUR;
	double		MINUTE;
	double		SECOND;
}CLOCK_ST;
/*--- GtFX --*/
typedef union{
	double		DATA[IGS_EPH_DATA_SIZE];
	struct{
		double		PRN_NUM;					// qPRNԍ
		CLOCK_ST	EPOCH;						// ̍q@bZ[W̊G|bN
		double		SV_CLOCK_BIAS;				/* NbN␳W@NbNoCAX[s] */
		double		SV_CLOCK_DRIFT;				/* NbN␳W@NbNhtgx[s/s] */
		double		SV_CLOCK_DRIFT_RATE;		/* NbN␳W@NbNhtgω[s/s^2] */
		double		IODE;						// Oԍ@Isuue of data, ephemeris
		double		Crs;						// O␳W[m]
		double		DELTA_N;					/* [rad/s] */
		double		M0;							/* ϋߓ_p[rad] */
		double		Cuc;						/* O␳W[rad] */
		double		e_ECCENTRICITY;				// S
		double		Cus;						/* O␳Wrad */
		double		SQRT_A;						/* Oa[m^1/2] */
		double		TOE;						/* G|bNiOjTime Of Ephemeris (sec of GPS week) */
		double		Cic;						/* O␳W[rad] */
		double		OMEGA;						/* _Ԍo[rad] */
		double		Cis;						/* O␳W[rad] */
		double		i0;							/* OXΊp[rad] */
		double		Crc;						/* O␳W[m] */
		double		omega;						/* ߒn_[rad] */
		double		OMEGA_DOT;					/* ̕ω[rad/s] */
		double		i_DOT;						/* i0̕ω[rad/s] */
		double		CODE_ON_L2_CH;
		double		GPS_WEEK_NUM;				// to go with TOE (Continuous number, not mod(1024)! )
		double		L2_P_DATA_FLAG;
		double		SV_ACCURACY;				// xH[m]
		double		SV_HEALTH;					// qN@0:OK 1`:s
		double		TGD;						/* Qx[s] */
		double		IODC;						// NbNԍ@Issue of Data, Clock
		double		TOM;						// transmission time of message (sec of GPS week, derived e.g. from Z-count in Hand Over Word (HOW)
		double		FIT_INTERVAL;				/* GtFX̗L[h]. Zero if not known. (see ICD-GPS-200, 20.3.4.4) */
		double		SPARE1;
		double		SPARE2;
	}ST;
}IGS_EPHEMERIS_UN;


/*--- A}ibN --*/
